﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Text.RegularExpressions;

//Here the user can add and delete contacts and see what contacts they have stored.
namespace cCam
{
    public partial class Contact : Form
    {

        private string name_contact;
        private string phone_contact;

        public Contact()
        {
            InitializeComponent();
            //When the form is open it will read from a .txt file and put the content into a drop down box
            string[] lineOfContents = File.ReadAllLines(@"C:\TEST\Contacts.txt");
            foreach (var line in lineOfContents)
            {
                list_of_persons.Items.Add(line);
            }


        }

        //When the addbutton is pressed the user must have filled in a correct name and phone number otherwise
        //they will not be able to save. This will then be stored in a .txt file. 
        private void add_person(object sender, MouseEventArgs e)
        {
            //Checks to see if both the name box and phone box is empty.
            if (String.IsNullOrEmpty(name_box.Text) || String.IsNullOrEmpty(phone_box.Text))
                System.Windows.MessageBox.Show("Text box can't be empty");
            else
            {

                //Checks to see if name contains ints.
                bool isDigitPresent_name = name_contact.Any(c => char.IsDigit(c));
                //Checks to see if name contains ints or phone contains strings. If it does it will show an error message
                //saying that the user input was incorrect
                if (isDigitPresent_name == true || IsDigitsOnly(phone_contact) == false)
                {
                    System.Windows.MessageBox.Show("Name or phone number was not entered correct. \nMake sure the name only contains letters and the phone number only constains numbers.");
                }

                //If everything was correct the name and phone number will be stored in the .txt file. 
                else
                {
                    File.AppendAllText(@"C:\TEST\Contacts.txt", name_contact + " " + phone_contact + "\n");
                    name_box.Text = String.Empty;
                    phone_box.Text = String.Empty;

                    list_of_persons.Items.Clear();
                    //The drop down box will be updated so that the new imput will be shown
                    string[] lineOfContents = File.ReadAllLines(@"C:\TEST\Contacts.txt");
                    foreach (var line in lineOfContents)
                    {
                        list_of_persons.Items.Add(line);
                    }
                }
            }
        }

        //Checks to see if phone number contains strings. If it does it will return false.
        static bool IsDigitsOnly(string str)
        {
            foreach (char c in str)
            {
                if (c < '0' || c > '9')
                    return false;
            }

            return true;
        }

        //Just to make sure the user does not mess things up by adding a bunch of spaces
        private void name_box_TextChanged(object sender, EventArgs e)
        {
            name_contact = name_box.Text;

            name_contact = name_contact.TrimEnd();
            name_contact = name_contact.TrimStart();

        }
        //Just to make sure the user does not mess things up with the phone number 
        private void phone_box_TextChanged(object sender, EventArgs e)
        {
            phone_contact = phone_box.Text;

            phone_contact = Regex.Replace(phone_contact, @"\s+", "");
        }

        //If the user have marked a name in the dropdown box they can delete it from the list by pressing
        //the delete button. The name will be deleted from the .txt file also and the dropdown box will be 
        //updated again.
        private void delete_person_Click(object sender, EventArgs e)
        {

            string line_to_delete = list_of_persons.Text;

            var oldLines = System.IO.File.ReadAllLines(@"C:\TEST\Contacts.txt");
            var newLines = oldLines.Where(line => !line.Contains(line_to_delete));
            System.IO.File.WriteAllLines(@"C:\TEST\Contacts.txt", newLines);

            list_of_persons.SelectedIndex = -1;
            list_of_persons.Items.Clear();

            string[] lineOfContents = File.ReadAllLines(@"C:\TEST\Contacts.txt");
            foreach (var line1 in lineOfContents)
            {
                list_of_persons.Items.Add(line1);
            }


        }
    }
}
